
#include <windows.h>

#include "lua_utility.h"

/*-------------------------------------
	NewVectorObject()
-------------------------------------*/
ILuaObject* NewVectorObject( lua_State* L, Vector& vec )
{

	ILuaObject* func = Lua()->GetGlobal( "Vector" );

	// Call into garry's implementation to create a vector.
	// I, for the life of me cannot figure out how to just push the raw vector
	// garry does some funky allocations, or something.
	// lua_newuserdata, lua_setmetatable, Lua()->NewTemporaryObject(), SetFromStack
	// nothing worked.
	Lua()->Push( func );
	Lua()->Push( vec.x );
	Lua()->Push( vec.y );
	Lua()->Push( vec.z );
	if( !Lua()->Call( 3, 1 ) )
	{

		func->UnReference();
		return NULL;

	}

	return Lua()->GetReturn( 0 );

}

/*-------------------------------------
	PushVector()
-------------------------------------*/
void PushVector( lua_State* L, Vector& vec )
{

	ILuaObject* obj = NewVectorObject( L, vec );
	Lua()->Push( obj );
	obj->UnReference();

}

/*-------------------------------------
	GetVector()
-------------------------------------*/
Vector& GetVector( lua_State* L, int stackPos )
{

	return *reinterpret_cast<Vector*>( Lua()->GetUserData( stackPos ) );
	
}
